unit AIProjectManager;
//************************************************************//
//                     AND Interpreter                       //
//  Eugene Hrulev (mrHru) Laxian Key, Omsk, Russia 1999,2001 //
//  Oleg Melnikov (muler) Laxian Key, Omsk, Russia 1999,2001 //
//************************************************************//

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Menus,

  AInterpreter, AIEditor, ComCtrls, Grids;

type
  TProjectManagerDialog = class(TCustomProjectManagerDialog)
    Panel1: TPanel;
    AddBtn: TBitBtn;
    DelBtn: TBitBtn;
    CloseBtn: TBitBtn;
    OpenBtn: TBitBtn;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    LV: TListView;
    procedure CloseBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure AddBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure DelBtnClick(Sender: TObject);
    procedure OpenBtnClick(Sender: TObject);
  private
  public
    Interpret   :TAInterpreter;
    constructor Create(AOwner:TComponent; AInterpret:TAInterpreter);reintroduce;
  end;

implementation

{$R *.DFM}

constructor TProjectManagerDialog.Create(AOwner:TComponent; AInterpret:TAInterpreter);
begin
  inherited Create(AOwner);

  Interpret:=AInterpret;
end;

procedure   TProjectManagerDialog.CloseBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TProjectManagerDialog.FormClose(Sender: TObject;  var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TProjectManagerDialog.FormShow(Sender: TObject);
var li:TListItem;
    i, idx:integer;
begin
  if (Interpret.ProjectName = '') or (not FileExists(Interpret.ProjectName)) then begin
    Interpret.FileSystem.FileName :='';
    Interpret.FileSystem.Filter   :='Projects (*.hsp)|*.HSP';
    if Interpret.FileSystem.OpenDialogExecute then
      if not Interpret.FileSystem.FileExists(Interpret.FileSystem.FileName) then begin
      try
        Interpret.ProjectList.SaveToStream(Interpret.FileSystem.CreateWriteStream(Interpret.FileSystem.FileName));
      finally
        Interpret.FileSystem.CloseWriteStream;
      end;
    end else begin
      Interpret.ProjectName:=Interpret.FileSystem.FileName;
      try
        Interpret.ProjectList.LoadFromStream(Interpret.FileSystem.CreateReadStream(Interpret.ProjectName));
      finally
        Interpret.FileSystem.CloseReadStream;
      end;
    end;

    idx:=Interpret.ProjectList.IndexOfName('AutoLoad');
    if idx <> -1 then begin
      Interpret.RunFile(Interpret.ProjectList.Values['AutoLoad']);
    end;
  end;

  for i:=0 to Interpret.ProjectList.Count - 1 do begin
    li:=LV.Items.Add;
    li.Caption:=Interpret.ProjectList.Names[i];
    li.SubItems.Add(Interpret.ProjectList.Values[Interpret.ProjectList.Names[i]]);
  end;

  LV.SetFocus;
end;

procedure TProjectManagerDialog.AddBtnClick(Sender: TObject);
var unitname:string;
    li:TListItem;
begin
  LV.SetFocus;

  Interpret.FileSystem.FileName :='';
  Interpret.FileSystem.Filter   :='Scripts (*.for)|*.FOR|Any files (*.*)|*.*';
  Interpret.FileSystem.Options  :=Interpret.FileSystem.Options + [ofCreatePrompt];

  if Interpret.FileSystem.OpenDialogExecute then begin
    unitname:=Interpret.FileSystem.ExtractFileNameOnly(Interpret.FileSystem.FileName);

    li:=LV.Items.Add;
    li.Caption:=unitname;
    li.SubItems.Add(Interpret.FileSystem.FileName);
    Interpret.ProjectList.Add(unitname + '=' + Interpret.FileSystem.FileName);

    try
      Interpret.ProjectList.SaveToStream(Interpret.FileSystem.CreateWriteStream(Interpret.ProjectName));
    finally
      Interpret.FileSystem.CloseWriteStream;
    end;
  end;
end;

procedure TProjectManagerDialog.DelBtnClick(Sender: TObject);
var i:integer;
begin
  LV.SetFocus;

  for i:=LV.Items.Count - 1 downto 0 do begin
    if LV.Items[i].Selected then begin
      Interpret.ProjectList.Delete(Interpret.ProjectList.IndexOfName(LV.Items[i].Caption));
      LV.Items.Delete(i);
    end;
  end;

  try
    Interpret.ProjectList.SaveToStream(Interpret.FileSystem.CreateWriteStream(Interpret.ProjectName));
  finally
    Interpret.FileSystem.CloseWriteStream;
  end;
end;

procedure TProjectManagerDialog.OpenBtnClick(Sender: TObject);
var i:integer;
begin
  for i:=LV.Items.Count - 1 downto 0 do begin
    if LV.Items[i].Selected then begin
      Self.Interpret.ShowEditorDialog(LV.Items[i].SubItems[0]);
    end;
  end;

  Close;
end;

end.
