unit AIReport;
//************************************************************//
//                     AND Interpreter                       //
//  Eugene Hrulev (mrHru) Laxian Key, Omsk, Russia 1999,2001 //
//  Oleg Melnikov (muler) Laxian Key, Omsk, Russia 1999,2001 //
//************************************************************//

interface

uses
  Classes, ARUserRep, SysUtils, DB, Graphics,

  ARUtils, AInterpreter, AIHandler;

type
  TAIUserRepHandler = class(TAIHandler)
  protected
    class procedure CM_ADDBANDS       (obj:TObject; PropList:TAIStringList; Ex:TContext);
    class procedure CM_ADDSUBBANDS    (obj:TObject; PropList:TAIStringList; Ex:TContext);
    class procedure CM_ADDSUBBANDSINTO(obj:TObject; PropList:TAIStringList; Ex:TContext);
    class procedure CM_DELETEBANDS    (obj:TObject; PropList:TAIStringList; Ex:TContext);
    class procedure CM_CLEARVALUES    (obj:TObject; PropList:TAIStringList; Ex:TContext);
    class procedure CM_PREVIEW        (obj:TObject; PropList:TAIStringList; Ex:TContext);
    class procedure CM_PAGEBREAK      (obj:TObject; PropList:TAIStringList; Ex:TContext);

    class procedure SetS    (obj:TObject; PropList:TAIStringList; D:TData);
    class procedure SetC    (obj:TObject; PropList:TAIStringList; D:TData);
    class procedure SetI    (obj:TObject; PropList:TAIStringList; D:TData);
    class procedure SetF    (obj:TObject; PropList:TAIStringList; D:TData);
    class procedure SetD    (obj:TObject; PropList:TAIStringList; D:TData);
    class procedure SetT    (obj:TObject; PropList:TAIStringList; D:TData);
    class procedure SetM    (obj:TObject; PropList:TAIStringList; D:TData);
    class procedure SetU    (obj:TObject; PropList:TAIStringList; D:TData);
    class procedure SetG    (obj:TObject; PropList:TAIStringList; D:TData);

    class function  GetS    (obj:TObject; PropList:TAIStringList):variant;
    class function  GetC    (obj:TObject; PropList:TAIStringList):variant;
    class function  GetI    (obj:TObject; PropList:TAIStringList):variant;
    class function  GetF    (obj:TObject; PropList:TAIStringList):variant;
    class function  GetD    (obj:TObject; PropList:TAIStringList):variant;
    class function  GetT    (obj:TObject; PropList:TAIStringList):variant;
    class function  GetU    (obj:TObject; PropList:TAIStringList):variant;
    class function  GetG    (obj:TObject; PropList:TAIStringList):variant;
    class function  GetCells(obj:TObject; PropList:TAIStringList):variant;

  public
    constructor   Create;override;
  end;

implementation

class procedure    TAIUserRepHandler.CM_ADDBANDS       (obj:TObject; PropList:TAIStringList; Ex:TContext);
var BandName:TData;
begin
  BandName:=Ex.PopDS;
  try
    Ex.PushDS(TVariant.Create(integer(TARUserRep(obj).AddBands(BandName.Value))));
  finally
    BandName.Free;
  end;
end;
class procedure    TAIUserRepHandler.CM_ADDSUBBANDS    (obj:TObject; PropList:TAIStringList; Ex:TContext);
var BandName:TData;
begin
  BandName:=Ex.PopDS;
  try
    Ex.PushDS(TVariant.Create(integer(TARUserRep(obj).AddSubBands(BandName.Value, false))));
  finally
    BandName.Free;
  end;
end;
class procedure    TAIUserRepHandler.CM_ADDSUBBANDSINTO(obj:TObject; PropList:TAIStringList; Ex:TContext);
var Expanded, Band, BandName:TData;
    bnd:integer;
begin
  Expanded:=Ex.PopDS;
  Band    :=Ex.PopDS;
  BandName:=Ex.PopDS;
  try
    bnd:=VarAsType(Band.Value, varInteger);
    Ex.PushDS(TVariant.Create(integer(TARUserRep(obj).AddSubBandsToBand(BandName.Value, pointer(bnd), Expanded.Value))));
  finally
    BandName.Free;
    Band.Free;
    Expanded.Free;
  end;
end;
class procedure   TAIUserRepHandler.CM_DELETEBANDS    (obj:TObject; PropList:TAIStringList; Ex:TContext);
begin
  TARUserRep(obj).DeleteBands;
end;
class procedure   TAIUserRepHandler.CM_CLEARVALUES    (obj:TObject; PropList:TAIStringList; Ex:TContext);
begin
  TARUserRep(obj).ClearValues;
end;
class procedure   TAIUserRepHandler.CM_PREVIEW        (obj:TObject; PropList:TAIStringList; Ex:TContext);
begin
  TARUserRep(obj).Preview;
end;
class procedure   TAIUserRepHandler.CM_PAGEBREAK      (obj:TObject; PropList:TAIStringList; Ex:TContext);
begin
  TARUserRep(obj).PageBreak;
end;

class procedure   TAIUserRepHandler.SetS(obj:TObject; PropList:TAIStringList; D:TData);
begin
  TARUserRep(obj).S[PropList[1]] :=D.Value;
end;
class procedure   TAIUserRepHandler.SetI(obj:TObject; PropList:TAIStringList; D:TData);
begin
  TARUserRep(obj).I[PropList[1]] :=D.Value;
end;
class procedure    TAIUserRepHandler.SetF(obj:TObject; PropList:TAIStringList; D:TData);
begin
  TARUserRep(obj).F[PropList[1]] :=D.Value;
end;
class procedure    TAIUserRepHandler.SetC(obj:TObject; PropList:TAIStringList; D:TData);
begin
  TARUserRep(obj).C[PropList[1]] :=D.Value;
end;
class procedure    TAIUserRepHandler.SetD(obj:TObject; PropList:TAIStringList; D:TData);
begin
  TARUserRep(obj).D[PropList[1]] :=D.Value;
end;
class procedure    TAIUserRepHandler.SetT(obj:TObject; PropList:TAIStringList; D:TData);
begin
  TARUserRep(obj).T[PropList[1]] :=D.Value;
end;
class procedure    TAIUserRepHandler.SetM(obj:TObject; PropList:TAIStringList; D:TData);
begin
  TARUserRep(obj).M[PropList[1]] :=D.Value;
end;
class procedure    TAIUserRepHandler.SetU(obj:TObject; PropList:TAIStringList; D:TData);
begin
  TARUserRep(obj).U[PropList[1]] :=D.Value;
end;
class procedure    TAIUserRepHandler.SetG(obj:TObject; PropList:TAIStringList; D:TData);
begin
  if VarAsObj(D.Value) is TGraphic then begin
    TARUserRep(obj).G[PropList[1]]:=VarAsObj(D.Value) as TGraphic;
  end;
end;

class function     TAIUserRepHandler.GetS(obj:TObject; PropList:TAIStringList):variant;
begin
  Result:=TARUserRep(obj).S[PropList[1]];
end;
class function     TAIUserRepHandler.GetI(obj:TObject; PropList:TAIStringList):variant;
begin
  Result:=TARUserRep(obj).I[PropList[1]];
end;
class function     TAIUserRepHandler.GetF(obj:TObject; PropList:TAIStringList):variant;
begin
  Result:=TARUserRep(obj).F[PropList[1]];
end;
class function     TAIUserRepHandler.GetC(obj:TObject; PropList:TAIStringList):variant;
begin
  Result:=TARUserRep(obj).C[PropList[1]];
end;
class function     TAIUserRepHandler.GetD(obj:TObject; PropList:TAIStringList):variant;
begin
  Result:=TARUserRep(obj).D[PropList[1]];
end;
class function     TAIUserRepHandler.GetT(obj:TObject; PropList:TAIStringList):variant;
begin
  Result:=TARUserRep(obj).T[PropList[1]];
end;
class function     TAIUserRepHandler.GetU(obj:TObject; PropList:TAIStringList):variant;
begin
  Result:=TARUserRep(obj).U[PropList[1]];
end;
class function     TAIUserRepHandler.GetG(obj:TObject; PropList:TAIStringList):variant;
begin
  Result:=ObjAsVar(TARUserRep(obj).G[PropList[1]]);
end;
class function     TAIUserRepHandler.GetCells(obj:TObject; PropList:TAIStringList):variant;
begin
  Result:=ObjAsVar(TARUserRep(obj).Cells(StrToInt(PropList[1]), StrToInt(PropList[2])));
end;

constructor   TAIUserRepHandler.Create;
begin
  inherited;

  AddMethod('ADDBANDS',         CM_ADDBANDS);
  AddMethod('ADDSUBBANDS',      CM_ADDSUBBANDS);
  AddMethod('ADDSUBBANDSINTO',  CM_ADDSUBBANDSINTO);
  AddMethod('DELETEBANDS',      CM_DELETEBANDS);
  AddMethod('CLEARVALUES',      CM_CLEARVALUES);
  AddMethod('PREVIEW',          CM_PREVIEW);
  AddMethod('PAGEBREAK',        CM_PAGEBREAK);
  
  AddProp('S',      GetS,     SetS,     2);
  AddProp('I',      GetI,     SetI,     2);
  AddProp('F',      GetF,     SetF,     2);
  AddProp('D',      GetD,     SetD,     2);
  AddProp('T',      GetT,     SetT,     2);
  AddProp('C',      nil,      SetC,     2);
  AddProp('M',      nil,      SetM,     2);
  AddProp('U',      GetU,     SetU,     2);
  AddProp('G',      GetG,     SetG,     2);
  AddProp('Cells',  GetCells, nil,      3);
end;

initialization
  RegisterHandler(TARUserRep, TAIUserRepHandler.Create);
end.




