unit AIReportForm;
//************************************************************//
//                     AND Interpreter                       //
//  Eugene Hrulev (mrHru) Laxian Key, Omsk, Russia 1999,2001 //
//  Oleg Melnikov (muler) Laxian Key, Omsk, Russia 1999,2001 //
//************************************************************//

interface

uses
  Classes, SysUtils, Graphics,

  ARUtils, AInterpreter, AIHandler, ARReportPreview;

type
  TAIReportPreviewHandler = class(TAIHandler)
  protected
    class procedure CM_ADDBANDS       (obj:TObject; PropList:TAIStringList; Ex:TContext);
    class procedure CM_ADDSUBBANDS    (obj:TObject; PropList:TAIStringList; Ex:TContext);
    class procedure CM_ADDSUBBANDSINTO(obj:TObject; PropList:TAIStringList; Ex:TContext);
    class procedure CM_DELETEBANDS    (obj:TObject; PropList:TAIStringList; Ex:TContext);
    class procedure CM_CLEARVALUES    (obj:TObject; PropList:TAIStringList; Ex:TContext);
    class procedure CM_PREVIEW        (obj:TObject; PropList:TAIStringList; Ex:TContext);
    class procedure CM_PAGEBREAK      (obj:TObject; PropList:TAIStringList; Ex:TContext);
    class procedure CM_STEPIT         (obj:TObject; PropList:TAIStringList; Ex:TContext);

    class procedure SetS    (obj:TObject; PropList:TAIStringList; D:TData);
    class procedure SetC    (obj:TObject; PropList:TAIStringList; D:TData);
    class procedure SetI    (obj:TObject; PropList:TAIStringList; D:TData);
    class procedure SetF    (obj:TObject; PropList:TAIStringList; D:TData);
    class procedure SetD    (obj:TObject; PropList:TAIStringList; D:TData);
    class procedure SetT    (obj:TObject; PropList:TAIStringList; D:TData);
    class procedure SetM    (obj:TObject; PropList:TAIStringList; D:TData);
    class procedure SetU    (obj:TObject; PropList:TAIStringList; D:TData);
    class procedure SetG    (obj:TObject; PropList:TAIStringList; D:TData);

    class function  GetS    (obj:TObject; PropList:TAIStringList):variant;
    class function  GetC    (obj:TObject; PropList:TAIStringList):variant;
    class function  GetI    (obj:TObject; PropList:TAIStringList):variant;
    class function  GetF    (obj:TObject; PropList:TAIStringList):variant;
    class function  GetD    (obj:TObject; PropList:TAIStringList):variant;
    class function  GetT    (obj:TObject; PropList:TAIStringList):variant;
    class function  GetU    (obj:TObject; PropList:TAIStringList):variant;
    class function  GetG    (obj:TObject; PropList:TAIStringList):variant;
    class function  GetCells(obj:TObject; PropList:TAIStringList):variant;

  public
    constructor   Create;override;
  end;

implementation

class procedure    TAIReportPreviewHandler.CM_ADDBANDS       (obj:TObject; PropList:TAIStringList; Ex:TContext);
var BandName:TData;
begin
  BandName:=Ex.PopDS;
  try
    Ex.PushDS(TVariant.Create(integer(TReportPreviewDlg(obj).AddBands(BandName.Value))));
  finally
    BandName.Free;
  end;
end;
class procedure    TAIReportPreviewHandler.CM_ADDSUBBANDS    (obj:TObject; PropList:TAIStringList; Ex:TContext);
var BandName:TData;
begin
  BandName:=Ex.PopDS;
  try
    Ex.PushDS(TVariant.Create(integer(TReportPreviewDlg(obj).AddSubBands(BandName.Value, false))));
  finally
    BandName.Free;
  end;
end;
class procedure    TAIReportPreviewHandler.CM_ADDSUBBANDSINTO(obj:TObject; PropList:TAIStringList; Ex:TContext);
var Expanded, Band, BandName:TData;
    bnd:integer;
begin
  Expanded:=Ex.PopDS;
  Band    :=Ex.PopDS;
  BandName:=Ex.PopDS;
  try
    bnd:=VarAsType(Band.Value, varInteger);
    Ex.PushDS(TVariant.Create(integer(TReportPreviewDlg(obj).AddSubBandsToBand(BandName.Value, pointer(bnd), Expanded.Value))));
  finally
    BandName.Free;
    Band.Free;
    Expanded.Free;
  end;
end;
class procedure   TAIReportPreviewHandler.CM_DELETEBANDS    (obj:TObject; PropList:TAIStringList; Ex:TContext);
begin
  TReportPreviewDlg(obj).DeleteBands();
end;
class procedure   TAIReportPreviewHandler.CM_CLEARVALUES    (obj:TObject; PropList:TAIStringList; Ex:TContext);
begin
  TReportPreviewDlg(obj).ClearValues();
end;
class procedure   TAIReportPreviewHandler.CM_PREVIEW        (obj:TObject; PropList:TAIStringList; Ex:TContext);
begin
  TReportPreviewDlg(obj).Preview();
end;
class procedure   TAIReportPreviewHandler.CM_PAGEBREAK      (obj:TObject; PropList:TAIStringList; Ex:TContext);
begin
  TReportPreviewDlg(obj).PageBreak();
end;
class procedure   TAIReportPreviewHandler.CM_STEPIT         (obj:TObject; PropList:TAIStringList; Ex:TContext);
begin
  TReportPreviewDlg(obj).StepIt();
end;

class procedure   TAIReportPreviewHandler.SetS(obj:TObject; PropList:TAIStringList; D:TData);
begin
  TReportPreviewDlg(obj).S[PropList[1]] :=D.Value;
end;
class procedure   TAIReportPreviewHandler.SetI(obj:TObject; PropList:TAIStringList; D:TData);
begin
  TReportPreviewDlg(obj).I[PropList[1]] :=D.Value;
end;
class procedure    TAIReportPreviewHandler.SetF(obj:TObject; PropList:TAIStringList; D:TData);
begin
  TReportPreviewDlg(obj).F[PropList[1]] :=D.Value;
end;
class procedure    TAIReportPreviewHandler.SetC(obj:TObject; PropList:TAIStringList; D:TData);
begin
  TReportPreviewDlg(obj).C[PropList[1]] :=D.Value;
end;
class procedure    TAIReportPreviewHandler.SetD(obj:TObject; PropList:TAIStringList; D:TData);
begin
  TReportPreviewDlg(obj).D[PropList[1]] :=D.Value;
end;
class procedure    TAIReportPreviewHandler.SetT(obj:TObject; PropList:TAIStringList; D:TData);
begin
  TReportPreviewDlg(obj).T[PropList[1]] :=D.Value;
end;
class procedure    TAIReportPreviewHandler.SetM(obj:TObject; PropList:TAIStringList; D:TData);
begin
  TReportPreviewDlg(obj).M[PropList[1]] :=D.Value;
end;
class procedure    TAIReportPreviewHandler.SetU(obj:TObject; PropList:TAIStringList; D:TData);
begin
  TReportPreviewDlg(obj).U[PropList[1]] :=D.Value;
end;
class procedure    TAIReportPreviewHandler.SetG(obj:TObject; PropList:TAIStringList; D:TData);
begin
  if VarAsObj(D.Value) is TGraphic then begin
    TReportPreviewDlg(obj).G[PropList[1]]:=VarAsObj(D.Value) as TGraphic;
  end;
end;

class function     TAIReportPreviewHandler.GetS(obj:TObject; PropList:TAIStringList):variant;
begin
  Result:=TReportPreviewDlg(obj).S[PropList[1]];
end;
class function     TAIReportPreviewHandler.GetI(obj:TObject; PropList:TAIStringList):variant;
begin
  Result:=TReportPreviewDlg(obj).I[PropList[1]];
end;
class function     TAIReportPreviewHandler.GetF(obj:TObject; PropList:TAIStringList):variant;
begin
  Result:=TReportPreviewDlg(obj).F[PropList[1]];
end;
class function     TAIReportPreviewHandler.GetC(obj:TObject; PropList:TAIStringList):variant;
begin
  Result:=TReportPreviewDlg(obj).C[PropList[1]];
end;
class function     TAIReportPreviewHandler.GetD(obj:TObject; PropList:TAIStringList):variant;
begin
  Result:=TReportPreviewDlg(obj).D[PropList[1]];
end;
class function     TAIReportPreviewHandler.GetT(obj:TObject; PropList:TAIStringList):variant;
begin
  Result:=TReportPreviewDlg(obj).T[PropList[1]];
end;
class function     TAIReportPreviewHandler.GetU(obj:TObject; PropList:TAIStringList):variant;
begin
  Result:=TReportPreviewDlg(obj).U[PropList[1]];
end;
class function     TAIReportPreviewHandler.GetG(obj:TObject; PropList:TAIStringList):variant;
begin
  Result:=ObjAsVar(TReportPreviewDlg(obj).G[PropList[1]]);
end;
class function     TAIReportPreviewHandler.GetCells(obj:TObject; PropList:TAIStringList):variant;
begin
  Result:=ObjAsVar(TReportPreviewDlg(obj).Cells(StrToInt(PropList[1]), StrToInt(PropList[2])));
end;

constructor   TAIReportPreviewHandler.Create;
begin
  inherited;

  AddMethod('ADDBANDS',         CM_ADDBANDS);
  AddMethod('ADDSUBBANDS',      CM_ADDSUBBANDS);
  AddMethod('ADDSUBBANDSINTO',  CM_ADDSUBBANDSINTO);
  AddMethod('DELETEBANDS',      CM_DELETEBANDS);
  AddMethod('CLEARVALUES',      CM_CLEARVALUES);
  AddMethod('PREVIEW',          CM_PREVIEW);
  AddMethod('PAGEBREAK',        CM_PAGEBREAK);
  AddMethod('STEPIT',           CM_STEPIT);

  AddProp('S',      GetS,     SetS,     2);
  AddProp('I',      GetI,     SetI,     2);
  AddProp('F',      GetF,     SetF,     2);
  AddProp('D',      GetD,     SetD,     2);
  AddProp('T',      GetT,     SetT,     2);
  AddProp('C',      nil,      SetC,     2);
  AddProp('M',      nil,      SetM,     2);
  AddProp('U',      GetU,     SetU,     2);
  AddProp('G',      GetG,     SetG,     2);
  AddProp('Cells',  GetCells, nil,      3);
end;

initialization
  RegisterHandler(TReportPreviewDlg, TAIReportPreviewHandler.Create());
end.




