unit MasterDetail;

uses SQL;

proc MasterDetailReport(object rep)
  rep.path     = FilePath(ParamStr(0)) + '..\..\AR\Demo\MasterDetail.ar';
  rep.title    = 'Master/detail report';
  rep.AutoStep = false;

  rep.AddBands('Title');
  rep.AddBands('Header');

  sql Q1; sql Q2;

  Q1.Add('SELECT * FROM CUSTOMER ORDER BY COMPANY');
  Q1.Open();
  rep.RecordCount = Q1.RecordCount;

  Q2.Add('SELECT * FROM ORDERS WHERE CUSTNO = :CUSTNO');
  Q2.Prepare();

  var Amount;
  while not(Q1.EOF) do
    rep.S.Company = Q1.S.COMPANY;
    rep.S.Contact = Q1.S.CONTACT;
    rep.S.Phone   = Q1.S.PHONE;
    rep.S.Fax     = Q1.S.FAX;
    rep.I.CustNo  = Q1.I.CUSTNO;
    rep.AddBands('Company');

    Q2.Close();
    Q2.I.CUSTNO   = Q1.I.CUSTNO;
    Q2.Open();
    Amount = 0;
    while not(Q2.EOF) do
      Amount = Amount + Q2.C.AMOUNTPAID;

      rep.I.OrderNo = Q2.I.ORDERNO;
      rep.D.Date    = Q2.D.SALEDATE;
      rep.M.Amount  = Q2.F.AMOUNTPAID;
      rep.AddBands('Amount');
      Q2.Next();
    endwhile

    rep.I.TotalOrders = Q2.RecordCount;
    rep.M.TotalAmount = Amount;
    rep.AddBands('Total');

    rep.StepIt();
    Q1.Next();
  endwhile

  rep.D.CurrDate = Now;
  rep.FixedBands = 2;
end

proc CreateMasterDetailReport()
  object rep;
  rep.create('TReportPreviewDlg');

  MasterDetailReport(rep);
end

//CreateMasterDetailReport();

