unit SeveralLevels;

uses SQL;

proc SeveralLevelsReport(object rep)
  rep.path      = FilePath(ParamStr(0)) + '..\..\AR\Demo\SeveralGroup.ar';
  rep.title     = 'Several groups report';
  rep.AutoStep  = false;

  rep.AddBands('Title');
  rep.AddBands('Header');

  sql Q;

  Q.Add('SELECT   * ');
  Q.Add('FROM     CUSTOMER C, ORDERS O, ITEMS I, PARTS P ');
  Q.Add('WHERE    C.CUSTNO = O.CUSTNO AND ');
  Q.Add('         O.ORDERNO = I.ORDERNO AND ');
  Q.Add('         I.PARTNO = P.PARTNO ');
  Q.Add('ORDER BY C.COMPANY, ORDERNO ');
  Q.Open();
  rep.RecordCount = Q.RecordCount;

  var Company;
  var TotalCustomer;
  var OrderNo;
  var TotalPrice;

  var band; var subband;

  Company = '';
  while not(Q.EOF) do
    if Company <> Q.S.COMPANY then
      Company       = Q.S.COMPANY;
      rep.S.Company = Q.S.COMPANY;
      band = rep.AddBands('Company');
    endif

    TotalCustomer = 0.0;
    while (not(Q.EOF)) and (Q.S.COMPANY == Company) do
      OrderNo = 0;
      if OrderNo <> Q.I.ORDERNO then
        OrderNo = Q.I.ORDERNO;
        rep.I.OrderNo  = OrderNo;
        rep.D.SaleDate = Q.D.SALEDATE;

        subband = rep.AddSubBandsInto('OrderNo', band, false);
        rep.AddSubBandsInto('PartHeader', subband, false);
      endif

      TotalPrice = 0.0;
      while (not(Q.EOF)) and (OrderNo == Q.I.ORDERNO) do
        TotalPrice = TotalPrice + Q.C.LISTPRICE;

        rep.I.PartNo      = Q.I.PARTNO;
        rep.S.Description = Q.S.DESCRIPTION;
        rep.C.ListPrice   = Q.C.LISTPRICE;
        rep.AddSubBandsInto('Detail', subband, false);
        rep.StepIt();

        Q.Next();
      endwhile
      rep.C.TotalPrice = TotalPrice;
      rep.AddSubBandsInto('OrderFooter', band, false);
      TotalCustomer = TotalCustomer + TotalPrice;
    endwhile
    rep.C.TotalCustomer = TotalCustomer;
    rep.AddBands('CompanyFooter');
  endwhile
end


proc CreateSeveralLevelsReport()
  object rep;
  rep.create('TReportPreviewDlg');

  SeveralLevelsReport(rep);
end

//CreateSeveralLevelsReport();  
                            
