unit TestList;

uses Report, SQL;

proc CreateBiolifeReport()
  report rep; 
  rep.create(); 
  rep.path = FilePath(ParamStr(0)) + 'Biolife.ar';
  rep.title = 'Biolife report';
  rep.AutoStep = false;

  sql Q;
  Q.Add('SELECT * FROM BIOLIFE');
  Q.Open();
  rep.RecordCount = Q.RecordCount;
  while not(Q.EOF) do 
    Rep.I.SpeciesNo   = Q.I.Species~No;
    Rep.S.Category    = Q.S.Category;
    Rep.S.CommonName  = Q.S.Common_Name;
    Rep.S.SpeciesName = Q.S.Species~Name;
    Rep.F.LengthCM    = Round(Q.F.Length_In * 2.54, 2);
    Rep.F.LengthIN    = Round(Q.F.Length_In, 2);
    Rep.S.Notes       = Q.S.Notes;
    Rep.G.Graphic     = Q.G.Graphic;
    Rep.AddBands('Band');

    rep.StepIt();
    Q.Next();
  endwhile
end

CreateBiolifeReport();


