unit UserRepTest;

Uses 
  FORMS, Report, SQL;


proc GenClick(form f)

  f.rep.path = FilePath(ParamStr(0)) + 'Biolife.ar';

  f.rep.title = 'Biolife report';
  f.rep.AutoStep = false;

  sql Q;
  Q.Add('SELECT * FROM BIOLIFE');
  Q.Open();

  while not(Q.EOF) do
    f.Rep.I.SpeciesNo   = Q.I.Species~No;
    f.Rep.S.Category    = Q.S.Category;
    f.Rep.S.CommonName  = Q.S.Common_Name;
    f.Rep.S.SpeciesName = Q.S.Species~Name;
    f.Rep.F.LengthCM    = Round(Q.F.Length_In * 2.54, 2);
    f.Rep.F.LengthIN    = Round(Q.F.Length_In, 2);
    f.Rep.S.Notes       = Q.S.Notes;
    f.Rep.G.Graphic     = Q.G.Graphic;
    f.Rep.AddBands('Band');

    f.rep.StepIt();
    Q.Next();
  endwhile

  f.bg.Caption = '&XXXXXX';
end

proc CloseClick(form f)
  f.close();
end

proc ShowForm();
  form f;
  f.formstyle = fsMDIChild;
  f.Bounds((ScreenWidth - 200) / 2, (ScreenHeight - 300) / 2, 400, 400);
  f.Create();
  f.Caption = 'AND Interpreter Demo ';

  userrep rep;
  rep.create(f); f.add(rep, 'rep'); rep.bounds(10, 10, 300, 300);

  button bg;
  bg.Create(f); f.add(bg, 'bg');
  bg.Bounds(((f.dx - bg.dx) / 2) - 50, f.dy - 70, bg.dx, bg.dy);
  bg.Caption = '&Generate';
  bg.default = yes;
  bg.OnClick = Addr(GenClick);
  f.Add(bg, 'bg');

  button bc;
  bc.Create(f);
  bc.Bounds(((f.dx - bc.dx) / 2) + 50, f.dy - 70, bc.dx, bc.dy);
  bc.Caption = '&Close';
  bc.cancel  = yes;
  bc.OnClick = Addr(CloseClick);
  f.Add(bc, 'bc');

end

ShowForm();


