unit ErrorMsg;
//************************************************************//
//                     AND Interpreter                       //
//  Eugene Hrulev (mrHru) Laxian Key, Omsk, Russia 1999,2001 //
//  Oleg Melnikov (muler) Laxian Key, Omsk, Russia 1999,2001 //
//************************************************************//

interface

uses
  SysUtils;

const
{$IFDEF LOCALE}
  errApplyPropToVariant           = '  <%s>   <VARIANT>';

  errRSEmpty                      = ' RS ';
  errDSEmpty                      = ' DS ';
  errUnterminatedString           = ' ';

  errInternalJampListEmpty        = ' :  JampList ';
  errInternalWordNotFound         = ' :    %s';
  errInternalPropIsNotString      = ' :   <%s>  ';
  errInternalWriteToNonEmptyCell  = ' : %s:   ';
  errInternalWhileDropWord        = ' :    <%s>, :<%s>';

  errRedeclareWord                = '   <%s>';
  errExpectedTerm                 = ' <%s>';
  errExpectedTypeName             = '  ';
  errIllegalParameters            = '   %s';
  errENDPROCwithoutPROC           = 'ENDPROC   PROC  FUNC';
  errOperatorNotApplicable        = ' %s      %s';
  errIllegalOperandTypeIn         = '    %s';
  errTHENWithoutIF                = 'THEN   IF';
  errELSEWithoutTHEN              = 'ELSE   THEN';
  errENDIFWithoutTHEN             = 'ENDIF   THEN';
  errDOWithoutWHILE               = 'DO   WHILE';
  errENDWHILEWithoutWHILE         = 'ENDWHILE   WHILE';
  errUndeclaredWord               = ' : <%s>';
  errIncompatibleTypes            = '  <%s>  <%s>';
  errUnitAlreadyDefined           = ' <%s>  ';
  errWORDinUNITAlreadyDefined     = ' <%s>   <%s>  ';
  errUnknownUnit                  = '  <%s>';
  errUnknownProperty              = '  <%s>  <%s>';

  errListAddList                  = '  <list.AddList()>    <list>';
  errPropReadingFromType          = '  <%s>   <%s>';
  errPropWritingToType            = '  <%s>   <%s>';
  errAssignmentToTypeValue        = '   <%s>  <%s.%s>';
  errCallMethod                   = '  <%s.%s>';
{$ELSE}
  errApplyPropToVariant           = 'applying <%s> property to type <VARIANT>';

  errRSEmpty                      = 'stack RS empty';
  errDSEmpty                      = 'stack DS empty';
  errUnterminatedString           = 'unterminated string';

  errInternalJampListEmpty        = 'INTERNAL ERROR: stack JampList empty';
  errInternalWordNotFound         = 'INTERNAL ERROR: word <%s> not found';
  errInternalPropIsNotString      = 'INTERNAL ERROR: applyed property <%s> not a string';
  errInternalWriteToNonEmptyCell  = 'INTERNAL ERROR: %s:write to nonempty cell';
  errInternalWhileDropWord        = 'INTERNAL ERROR: incorrect word deletes <%s>, value:<%s>';

  errRedeclareWord                = 'rederclared word <%s>';
  errExpectedTerm                 = 'needed <%s>';
  errExpectedTypeName             = 'required type name';
  errIllegalParameters            = 'illegal parameters for %s';
  errENDPROCwithoutPROC           = 'ENDPROC without PROC or FUNC';
  errOperatorNotApplicable        = 'operator %s not applicable to to operands type %s';
  errIllegalOperandTypeIn         = 'invalid operand type in %s';
  errTHENWithoutIF                = 'THEN without IF';
  errELSEWithoutTHEN              = 'ELSE without THEN';
  errENDIFWithoutTHEN             = 'ENDIF without THEN';
  errDOWithoutWHILE               = 'DO without WHILE';
  errENDWHILEWithoutWHILE         = 'ENDWHILE without WHILE';
  errUndeclaredWord               = 'unknown word: <%s>';
  errIncompatibleTypes            = 'incompatible types <%s> and <%s>';
  errUnitAlreadyDefined           = 'unit <%s> already exists';
  errWORDinUNITAlreadyDefined     = 'name <%s> in unit <%s> already exists';
  errUnknownUnit                  = 'unknown unit <%s>';
  errUnknownProperty              = 'unknown property <%s> on <%s>';

  errUnknownClass                 = 'unknown type <%s>';
  errListAddList                  = 'parameter <list.AddList()> must be type <list>';
  errPropReadingFromType          = 'reading property <%s> from <%s>';
  errPropWritingToType            = 'writing property <%s> from <%s>';
  errAssignmentToTypeValue        = 'assignment to type <%s> value <%s.%s>';
  errCallMethod                   = 'call method <%s> from <%s>';
  errCallUndeclaredMethod         = 'call undeclared method <%s> from <%s>';
  errUndeclaredEvent              = 'call undeclared event <%s> from <%s>';

  errIllegalLibrary               = '<RegisterWords> entry point not found in <%s>';
{$ENDIF}

procedure  Error(const Msg:string; const Args:array of const);

implementation

procedure  Error(const Msg:string; const Args:array of const);
begin
  raise Exception.CreateFmt(Msg, Args);
end;

end.
