unit ReplaceText;
//************************************************************//
//                     AND Interpreter                       //
//  Eugene Hrulev (mrHru) Laxian Key, Omsk, Russia 1999,2001 //
//  Oleg Melnikov (muler) Laxian Key, Omsk, Russia 1999,2001 //
//************************************************************//

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls;

type
  TReplaceTextDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Label1: TLabel;
    TextToFindCB: TComboBox;
    GroupBox1: TGroupBox;
    MatchCaseCB: TCheckBox;
    WholeWordCB: TCheckBox;
    Label2: TLabel;
    TextToReplaceCB: TComboBox;
    AllBtn: TBitBtn;
    PromptCB: TCheckBox;
    AllFilesCB: TCheckBox;
    procedure OKBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure AllBtnClick(Sender: TObject);
  private
  public
    WholeWord       :boolean;
    MatchCase       :boolean;
    Prompt          :boolean;
    AllFiles        :boolean;
    TextToFind      :string;
    TextToReplace   :string;

    function    Execute:boolean;
  end;

implementation

{$R *.DFM}

function    TReplaceTextDlg.Execute:boolean;
begin
  TextToFindCB.Text     :=TextToFind;
  TextToReplaceCB.Text  :=TextToReplace;

  ShowModal;

  Result:=(ModalResult = mrOK) or (ModalResult = mrAll);
end;

procedure TReplaceTextDlg.FormActivate(Sender: TObject);
begin
  TextToFindCB.SetFocus;
end;

procedure   TReplaceTextDlg.OKBtnClick(Sender: TObject);
var idx:integer;
begin
  idx:=TextToFindCB.Items.IndexOf(TextToFindCB.Text);
  if idx = -1 then TextToFindCB.Items.Insert(0, TextToFindCB.Text);

  idx:=TextToReplaceCB.Items.IndexOf(TextToReplaceCB.Text);
  if idx = -1 then TextToReplaceCB.Items.Insert(0, TextToReplaceCB.Text);

  TextToFind    :=TextToFindCB.Text;
  TextToReplace :=TextToReplaceCB.Text;
  WholeWord     :=WholeWordCB.Checked;
  MatchCase     :=MatchCaseCB.Checked;
  Prompt        :=PromptCB.Checked;
  AllFiles      :=AllFilesCB.Checked;

  ModalResult:=mrOK;
end;

procedure TReplaceTextDlg.AllBtnClick(Sender: TObject);
var idx:integer;
begin
  idx:=TextToFindCB.Items.IndexOf(TextToFindCB.Text);
  if idx = -1 then TextToFindCB.Items.Insert(0, TextToFindCB.Text);

  idx:=TextToReplaceCB.Items.IndexOf(TextToReplaceCB.Text);
  if idx = -1 then TextToReplaceCB.Items.Insert(0, TextToReplaceCB.Text);

  TextToFind    :=TextToFindCB.Text;
  TextToReplace :=TextToReplaceCB.Text;
  WholeWord     :=WholeWordCB.Checked;
  MatchCase     :=MatchCaseCB.Checked;
  Prompt        :=PromptCB.Checked;
  AllFiles      :=AllFilesCB.Checked;

  ModalResult:=mrAll;
end;

end.
