unit AREditorObjectList;
//************************************************************//
//                         AND Report                        //
//  Eugene Hrulev (mrHru) Laxian Key, Omsk, Russia 1999,2001 //
//  Oleg Melnikov (muler) Laxian Key, Omsk, Russia 1999,2001 //
//************************************************************//

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, Buttons, ExtCtrls, IniFiles, Grids,

  ARUtils, ARResStrings;

type
  TObjectsDialog = class(TForm)
    Bevel1: TBevel;
    AddBtn: TBitBtn;
    DeleteBtn: TBitBtn;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    PopupMenu: TPopupMenu;
    AddMenuItem: TMenuItem;
    DeleteMenuItem: TMenuItem;
    ObjectsSG: TStringGrid;
    procedure AddBtnClick(Sender: TObject);
    procedure DeleteBtnClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    Objects    :TAIStringList;
  end;

implementation

{$R *.DFM}

procedure TObjectsDialog.AddBtnClick(Sender: TObject);
begin
  ObjectsSG.RowCount:=ObjectsSG.RowCount + 1;
  ObjectsSG.Cells[0, ObjectsSG.RowCount - 1]  :=rsAREditorObjectList_NewObject;
  ObjectsSG.Objects[0, ObjectsSG.RowCount - 1]:=nil;

  with ObjectsSG.Selection do begin
    Top    :=ObjectsSG.RowCount - 1;
    Bottom:=ObjectsSG.RowCount - 1;
  end;
end;

procedure TObjectsDialog.DeleteBtnClick(Sender: TObject);
var i:integer;
begin
  for i:=ObjectsSG.Selection.Top + 1 to ObjectsSG.RowCount - 1 do begin
    ObjectsSG.Cells[0, i - 1]:=ObjectsSG.Cells[0, i];
  end;
  ObjectsSG.RowCount:=ObjectsSG.RowCount - 1;
end;

procedure TObjectsDialog.CancelBtnClick(Sender: TObject);
begin
  ModalResult:=mrCancel;
end;

procedure TObjectsDialog.FormShow(Sender: TObject);
begin
  ObjectsSG.RowCount:=Objects.Count;
  ObjectsSG.Cols[0].Assign(Objects);
  with ObjectsSG.Selection do begin
    Left  :=0;
    Right  :=0;
    Top    :=0;
    Bottom:=0;
  end;
end;

procedure TObjectsDialog.FormDestroy(Sender: TObject);
begin
  Objects.Free;
end;

procedure TObjectsDialog.OKBtnClick(Sender: TObject);
var inf:TIniFile;
    i,imax:integer;
begin
  imax:=0;
  for i:=0 to ObjectsSG.RowCount - 1 do begin
    if imax < integer(ObjectsSG.Objects[0, i]) then imax:=integer(ObjectsSG.Objects[0, i]);
  end;

  Objects.Clear;
  for i:=0 to ObjectsSG.RowCount - 1 do begin
    Objects.Add(ObjectsSG.Cells[0, i]);
    if (ObjectsSG.Objects[0, i] = nil) or (Objects.IndexOfObject(ObjectsSG.Objects[0, i]) <> -1) then begin
      inc(imax);
      Objects.Objects[i]:=pointer(imax);
    end else begin
      Objects.Objects[i]:=ObjectsSG.Objects[0, i];
    end;
  end;

  inf:=TIniFile.Create('ANDReport.ini');

  try
    for i:=0 to Objects.Count - 1 do begin
      inf.WriteInteger('Objects', Objects[i], integer(Objects.Objects[i]));
    end;
  finally
    inf.Free;
  end;

  ModalResult:=mrOK;
end;

procedure TObjectsDialog.FormCreate(Sender: TObject);
begin
  Objects:=TAIStringList.Create('TObjectsDialog.Objects');

  Caption               :=rsAREditorObjectList_Caption;
  AddBtn.Caption        :=rsAREditorObjectList_AddBtn;
  DeleteBtn.Caption     :=rsAREditorObjectList_DeleteBtn;
  OKBtn.Caption         :=rsAREditorObjectList_OKBtn;
  CancelBtn.Caption     :=rsAREditorObjectList_CancelBtn;
  AddMenuItem.Caption   :=rsAREditorObjectList_AddMenuItem;
  DeleteMenuItem.Caption:=rsAREditorObjectList_DeleteMenuItem;
end;

end.
