unit AREditorOptions;
//************************************************************//
//                         AND Report                        //
//  Eugene Hrulev (mrHru) Laxian Key, Omsk, Russia 1999,2001 //
//  Oleg Melnikov (muler) Laxian Key, Omsk, Russia 1999,2001 //
//************************************************************//

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ComCtrls, Menus,

  ARUtils, ARRepCommon;

type
  TARPreferecesDlg = class(TForm)
    PageControl1: TPageControl;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    TabSheet1: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    GridXEdit: TEdit;
    GridYEdit: TEdit;
    UnitLabel1: TLabel;
    UnitLabel2: TLabel;
    procedure OKBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure RegCBClick(Sender: TObject);
  private
    fChanged:boolean;
  public
    Units         :TARUnits;

    GridX         :extended;
    GridY         :extended;
  end;

var
  ARPreferecesDlg: TARPreferecesDlg;

implementation

uses AREditorMain;

{$R *.DFM}

procedure TARPreferecesDlg.CancelBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TARPreferecesDlg.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TARPreferecesDlg.OKBtnClick(Sender: TObject);
var Edit:TEdit;
begin
  Edit:=GridXEdit;
  try
                      GridX    :=StrToFloat(Edit.Text);
    Edit:=GridYEdit;  GridY    :=StrToFloat(Edit.Text);
  except
    Edit.SelectAll;
    Edit.SetFocus;
    exit;
  end;
end;

procedure TARPreferecesDlg.RegCBClick(Sender: TObject);
begin
  fChanged:=true;
end;

procedure TARPreferecesDlg.FormShow(Sender: TObject);
begin
  GridXEdit.Text    :=Format('%.2f', [GridX]);
  GridYEdit.Text    :=Format('%.2f', [GridY]);
  UnitLabel1.Caption:=UnitsShortName(Units);
  UnitLabel2.Caption:=UnitsShortName(Units);
end;

end.
