unit ARPropEditor;
//************************************************************//
//                         AND Report                        //
//  Eugene Hrulev (mrHru) Laxian Key, Omsk, Russia 1999,2001 //
//  Oleg Melnikov (muler) Laxian Key, Omsk, Russia 1999,2001 //
//************************************************************//

interface

uses
  Windows, Classes, Graphics, Forms, Controls, Buttons, DsgnIntf,
  DsgnWnds, StdCtrls, ComCtrls, SysUtils,

  ARRep,
  ARGridRep,
  AREditorMain;

type
  TARTemplateProperty = class(TClassProperty)
  public
    procedure Edit; override;
    function  GetAttributes: TPropertyAttributes; override;
  end;

  TARTemplateEditor = class(TDefaultEditor)
  protected
    procedure EditProperty(PropertyEditor: TPropertyEditor;
                           var Continue, FreeEditor: Boolean); override;
  public
    procedure ExecuteVerb(Index: Integer); override;
    function  GetVerb(Index: Integer): string; override;
    function  GetVerbCount: Integer; override;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponentEditor(TARGridRep, TARTemplateEditor);
  RegisterPropertyEditor(TypeInfo(TARTemplate), nil, 'ARTemplate', TARTemplateProperty);
end;

procedure TARTemplateProperty.Edit;
var AREditor: TAREditorDlg;
begin
  AREditor := TAREditorDlg.Create(Application);
  try
    AREditor.SetEditingRep(TARGridRep(GetComponent(0)));
    AREditor.ShowModal;
  finally
    AREditor.Free;
  end;
end;

function TARTemplateProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog];
end;

{TARTemplateEditor}
procedure TARTemplateEditor.EditProperty(PropertyEditor: TPropertyEditor;
  var Continue, FreeEditor: Boolean);
var
  PropName: string;
begin
  PropName := PropertyEditor.GetName;
  if (CompareText(PropName, 'ARTemplate') = 0) then begin
    PropertyEditor.Edit;
//    PropertyEditor.Modified;
    Continue  :=False;
    FreeEditor:=true;
  end;
end;

function TARTemplateEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

function TARTemplateEditor.GetVerb(Index: Integer): string;
begin
  if Index = 0 then begin
    Result := 'Edit AND Report &Template...'
  end else begin
    Result := '';
  end;
end;

procedure TARTemplateEditor.ExecuteVerb(Index: Integer);
begin
  if Index = 0 then Edit;
end;

end.
