unit ARSFSSetup;
//************************************************************//
//                         AND Report                        //
//  Eugene Hrulev (mrHru) Laxian Key, Omsk, Russia 1999,2001 //
//  Oleg Melnikov (muler) Laxian Key, Omsk, Russia 1999,2001 //
//************************************************************//

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ComCtrls, Menus, Registry,

  ARUtils, ARRepCommon;

type
  TARSFSSetupDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    GroupBox1: TGroupBox;
    FTLB: TListBox;
    RegCB: TCheckBox;
    ExtPopupMenu: TPopupMenu;
    AddMenuItem: TMenuItem;
    DelMenuItem: TMenuItem;
    procedure AddMenuItemClick(Sender: TObject);
    procedure DelMenuItemClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure RegCBClick(Sender: TObject);
  private
    fChanged      :boolean;
    DelList       :TAIStringList;
    function      GetExtList:TStrings;
  public
    property      ExtList:TStrings read  GetExtList;
  end;

implementation

{$R *.DFM}

procedure TARSFSSetupDlg.AddMenuItemClick(Sender: TObject);
var s:string;
begin
  s:=InputBox('New file type', 'Input file extension', '');
  if Length(s) > 0 then begin
    FTLB.Items.Add(s);
    fChanged:=true;
  end;
end;

procedure TARSFSSetupDlg.DelMenuItemClick(Sender: TObject);
var i:integer;
begin
  for i:=FTLB.Items.Count - 1 downto 0 do begin
    if FTLB.Selected[i] then begin
      DelList.Add(FTLB.Items[i]);
      FTLB.Items.Delete(i);
      fChanged:=true;
    end;
  end;
end;

procedure TARSFSSetupDlg.CancelBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TARSFSSetupDlg.OKBtnClick(Sender: TObject);
var reg:TRegistry;
    i:integer;
begin
  if fChanged then begin
    reg:=TRegistry.Create;
    try
      reg.RootKey := HKEY_CLASSES_ROOT;
        for i:=0 to DelList.Count - 1 do begin
          reg.DeleteKey('\.' + DelList[i]);
        end;

        for i:=0 to FTLB.Items.Count -1 do begin
          reg.OpenKey('\.' + FTLB.Items[i], True);
          reg.WriteString('', 'ARTemplate');
        end;

      if RegCB.Checked then begin
        reg.RootKey := HKEY_CLASSES_ROOT;
        reg.OpenKey('\ARTemplate', true);
        reg.WriteString('', 'AND Report template');

        reg.OpenKey('\ARTemplate\DefaultIcon', True);
        reg.WriteString('', ParamStr(0) + ',0');

        reg.OpenKey('\ARTemplate\Shell', True);
        reg.OpenKey('\ARTemplate\Shell\Open\Command', True);
        reg.WriteString('', ParamStr(0) + ' %1');
        reg.OpenKey('\ARTemplate\Shell\Print\Command', True);
        reg.WriteString('', ParamStr(0) + ' /p %1');
        reg.OpenKey('\ARTemplate\Shell\View\Command', True);
        reg.WriteString('', ParamStr(0) + ' /v %1');
      end else begin
        reg.RootKey := HKEY_CLASSES_ROOT;
        reg.DeleteKey('\ARTemplate');
      end;
    finally
      reg.Free;
    end;
  end;
end;

procedure TARSFSSetupDlg.FormCreate(Sender: TObject);
begin
  DelList:=TAIStringList.Create('TARPreferecesDlg.DelList');
end;

procedure TARSFSSetupDlg.FormDestroy(Sender: TObject);
begin
  DelList.Free;
end;

procedure TARSFSSetupDlg.RegCBClick(Sender: TObject);
begin
  fChanged:=true;
end;

procedure TARSFSSetupDlg.FormShow(Sender: TObject);
var reg:TRegistry;
begin
  reg:=TRegistry.Create;
  try
    reg.RootKey := HKEY_CLASSES_ROOT;

    RegCB.Checked:=reg.OpenKey('\ARTemplate', false);
  finally
    reg.Free;
  end;
end;

function  TARSFSSetupDlg.GetExtList:TStrings;
begin
  Result:=FTLB.Items;
end;

end.
