unit ExpandOnDemand;
//************************************************************//
//                         AND Report                        //
//  Eugene Hrulev (mrHru) Laxian Key, Osmk, Russia 1999,2000 //
//  Oleg Melnikov (muler) Laxian Key, Osmk, Russia 1999,2000 //
//************************************************************//

interface

uses
  SysUtils,

  ARSQL, ARRep, ARUserRep;

procedure ExpandOnDemandReport(Rep: TARUserRep);

implementation

uses Main;

procedure OnSelectBand(Rep:TARUserRep; IdxBand: Integer);forward;

procedure ExpandOnDemandReport(Rep: TARUserRep);
var Q:TSQL;
    band:TARBand;
begin
	Rep.Load(ExtractFilePath(ParamStr(0)) + '\SeveralGroup.ar');
  Rep.Title:='Several group report - expand on demain';

	Rep.AddBands('Title');
	Rep.AddBands('Header');

	Q:=TSQL.CreateDB(DemoDlg.Database1);
	try
		Q.Add('SELECT C.COMPANY, C.CUSTNO, SUM(LISTPRICE) AS TOTALCUSTOMER ');
		Q.Add('FROM   CUSTOMER C, ORDERS O, ITEMS I, PARTS P ');
		Q.Add('WHERE  C.CUSTNO = O.CUSTNO ');
		Q.Add('       AND O.ORDERNO = I.ORDERNO ');
		Q.Add('       AND I.PARTNO = P.PARTNO ');
		Q.Add('GROUP BY C.COMPANY, C.CUSTNO ');
		Q.Open;
		DemoDlg.ProgressBar.Position:=0;
		DemoDlg.ProgressBar.Max:=Q.RecordCount;

		while not Q.EOF do begin
      Rep.BeginPara;
			Rep.S['Company']:=Q.S['COMPANY'];
			band:=Rep.AddBands('Company');
			band.Marked:=true;
      band.ID:=Q.I['CUSTNO'];

			Rep.C['TotalCustomer']:=Q.C['TOTALCUSTOMER'];
			Rep.AddBands('CompanyFooter');

			Q.Next;
			DemoDlg.ProgressBar.StepIt;
  	end;

    SelectBand:=OnSelectBand;
	finally
		Q.Free;
	end;
end;

procedure OnSelectBand(Rep:TARUserRep; IdxBand: Integer);
var Q:TSQL;
    band, subband:TARBand;
		OrderNo:integer;
begin
  band:=TARBand(Rep.SrcRep[IdxBand]);

  if band.Expandable then begin
    band.Expanded:= not band.Expanded;
    Rep.Invalidate;
  end else begin
    if band.Marked then begin
    	Q:=TSQL.CreateDB(DemoDlg.Database1);
      try
  	  	if CompareText(band.Name, 'Company') = 0 then begin
          Q.Add('SELECT ORDERNO, SALEDATE, SUM(LISTPRICE) AS TOTALPRICE ');
          Q.Add('FROM   ORDERS O, ITEMS I, PARTS P ');
          Q.Add('WHERE  O.CUSTNO      = :CUSTNO ');
          Q.Add('       AND O.ORDERNO = I.ORDERNO ');
          Q.Add('       AND I.PARTNO  = P.PARTNO ');
          Q.Add('GROUP  BY ORDERNO, SALEDATE ');
          Q.I['CUSTNO']:=band.ID;
          Q.Open;
      		while not Q.EOF do begin
						OrderNo:=Q.I['ORDERNO'];
						Rep.I['OrderNo']	:=OrderNo;
						Rep.D['SaleDate']	:=Q.D['SALEDATE'];
						subband:=Rep.AddBands('OrderNo', band, true);
						subband.ID:=OrderNo;
            subband.Marked:=true;
						Rep.C['TotalPrice']	:=Q.C['TOTALPRICE'];
						Rep.AddBands('OrderFooter', band, true);
            Q.Next;
          end;
        end else
  	  	if CompareText(band.Name, 'OrderNo') = 0 then begin
					Rep.AddBands('PartHeader', band, false);
          Q.Add('SELECT * ');
          Q.Add('FROM   ITEMS I, PARTS P ');
          Q.Add('WHERE  I.ORDERNO     = :ORDERNO ');
          Q.Add('       AND I.PARTNO  = P.PARTNO ');
          Q.I['ORDERNO']:=band.ID;
          Q.Open;
      		while not Q.EOF do begin
						Rep.I['PartNo']			:=Q.I['PARTNO'];
						Rep.S['Description']:=Q.S['DESCRIPTION'];
						Rep.C['ListPrice']	:=Q.C['LISTPRICE'];
						Rep.AddBands('Detail', band, true);
						Q.Next;
          end;
        end;
        band.Marked:=false;
      finally
      	Q.Free;
      end;
    end;
  end;
end;

end.

