unit Main;
//************************************************************//
//                         AND Report                        //
//  Eugene Hrulev (mrHru) Laxian Key, Osmk, Russia 1999,2000 //
//  Oleg Melnikov (muler) Laxian Key, Osmk, Russia 1999,2000 //
//************************************************************//

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, DBTables, StdCtrls, Buttons, ExtCtrls, ComCtrls, Db,

	ARUtils, ARSQL, ARVFS, ARGridRep, ARUserRep,	AREditRep, ARRepCommon,

  Biolife,        Clients,  Simple,   Group, MasterDetail, SeveralGroup,
  ExpandOnDemand, Calendar, TrickTrak;

type
  TReportDblClickEventHandler   = procedure(Rep: TARUserRep);
  TReportCanEditEventHandler    = procedure(Rep: TARUserRep; IdxBand:integer; IdxCell:integer; var CanEdit:boolean);
  TReportCellChangeEventHandler = procedure(Rep: TARUserRep; IdxBand:integer; IdxCell:integer);

	TDemoDlg = class(TForm)
    Panel: TPanel;
		CloseBtn: TBitBtn;
		Database1: TDatabase;
		PreviewBtn: TBitBtn;
		Image1: TImage;
		Label1: TLabel;
		RepSelectRG: TRadioGroup;
		Bevel1: TBevel;
		ReportBtn: TBitBtn;
    StatusBar: TStatusBar;
    ProgressBar: TProgressBar;
    UserRep: TARUserRep;
    FocusedCellStyleRG: TRadioGroup;
    SelectedCellStyleRG: TRadioGroup;
		procedure CloseBtnClick(Sender: TObject);
		procedure PreviewBtnClick(Sender: TObject);
		procedure ReportBtnClick(Sender: TObject);
    procedure UserRepSelectBand(Sender: TObject; IdxBand: Integer);
    procedure FormShow(Sender: TObject);
    procedure FocusedCellStyleRGClick(Sender: TObject);
    procedure SelectedCellStyleRGClick(Sender: TObject);
	private
	public
		procedure CompositeReport(Rep: TARUserRep);
	end;

var
	DemoDlg: TDemoDlg;

var SelectBand:procedure (Rep:TARUserRep; IdxBand: Integer);

implementation

{$R *.DFM}

procedure TDemoDlg.CompositeReport(Rep: TARUserRep);
begin
	BiolifeReport(UserRep);
  UserRep.PageBreak;

  ClientsReport(UserRep);
  UserRep.PageBreak;

	SimpleReport(UserRep);
  UserRep.PageBreak;

	GroupReport(UserRep);
  UserRep.PageBreak;

	MasterDetailReport(UserRep);
  UserRep.PageBreak;

	SeveralGroupReport(UserRep);
  UserRep.PageBreak;

  ExpandOnDemandReport(UserRep);

  UserRep.FixedBands:=0;
end;

procedure TDemoDlg.CloseBtnClick(Sender: TObject);
begin
	Close;
end;

procedure TDemoDlg.PreviewBtnClick(Sender: TObject);
begin
	UserRep.Preview;
end;

procedure TDemoDlg.ReportBtnClick(Sender: TObject);
begin
  UserRep.Columns:=0;
  UserRep.Hint:='';
  SelectBand:=nil;

	Panel.Enabled:=false;
	try
		UserRep.DeleteBands;

		case RepSelectRG.ItemIndex of
			0:	BiolifeReport(UserRep);
      1:  ClientsReport(UserRep);
			2:	SimpleReport(UserRep);
			3:	GroupReport(UserRep);
			4:	MasterDetailReport(UserRep);
			5:	SeveralGroupReport(UserRep);
			6:	ExpandOnDemandReport(UserRep);
			7:	CompositeReport(UserRep);
			8:	CalendarReport(UserRep);
			9:	ShowGame;
		end;

		UserRep.SetFocus;
	finally
		Panel.Enabled:=true;
	end;
end;

procedure TDemoDlg.UserRepSelectBand(Sender: TObject; IdxBand: Integer);
begin
  if Assigned(SelectBand) then begin
    SelectBand(Sender as TARUserRep, IdxBand);
  end;
end;

procedure TDemoDlg.FormShow(Sender: TObject);
begin
  ReportBtnClick(Self);
//  PreviewBtnClick(Self);
end;

procedure TDemoDlg.FocusedCellStyleRGClick(Sender: TObject);
begin
  UserRep.FocusedCellStyle:=TFocusedCellStyle(FocusedCellStyleRG.ItemIndex);
end;

procedure TDemoDlg.SelectedCellStyleRGClick(Sender: TObject);
begin
  UserRep.SelectedCellStyle:=TSelectedCellStyle(SelectedCellStyleRG.ItemIndex);
end;

end.


