unit ExecCMDForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons,

  SyncTools;

type
  TExecCMDDlg = class(TForm)
    BitBtn1: TBitBtn;
    Label1: TLabel;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
  public
    Terminated  :boolean;
  end;

procedure ExecCMD(const FileName:string; const Params:string; const DefaultDir:string; ShowCmd: Integer; Caption:string);

implementation

{$R *.DFM}

procedure TExecCMDDlg.BitBtn1Click(Sender: TObject);
begin
  Terminated:=true;
  Error(' ', []);
end;

procedure TExecCMDDlg.FormShow(Sender: TObject);
begin
  Terminated:=false;
end;

function ExecuteFile(const FileName, Params, DefaultDir: string; ShowCmd: Integer): integer;
var zFileName, zParams, zDir:PChar;
    pi:TProcessInformation;
    si:TStartupInfo;
begin
  with si do begin
    cb              :=Sizeof(si);
    lpReserved      :=nil;
    lpDesktop       :=nil;
    lpTitle         :=nil;
    dwX             :=0;
    dwY             :=0;
    dwXSize         :=0;
    dwYSize         :=0;
    dwXCountChars   :=0;
    dwYCountChars   :=0;
    dwFillAttribute :=0;
    dwFlags         :=0;
    wShowWindow     :=0;
    cbReserved2     :=0;
    lpReserved2     :=nil;
    hStdInput       :=0;
    hStdOutput      :=0;
    hStdError       :=0;
  end;

  GetMem(zFileName,   Length(FileName) + 2);
  GetMem(zParams,     Length(Params) + 2);
  GetMem(zDir,        Length(DefaultDir) + 2);

  StrPCopy(zFileName, FileName);
  StrPCopy(zParams,   Params);
  StrPCopy(zDir,      DefaultDir);

  if not CreateProcess(
      zFileName,                      // pointer to name of executable module
      zParams,                        // pointer to command line string
      nil,	                          // pointer to process security attributes
      nil,	                          // pointer to thread security attributes
      true, 	                        // handle inheritance flag
      0,	                            // creation flags
      nil,	                          // pointer to new environment block
      zDir,                           // pointer to current directory name
      si,	                            // pointer to STARTUPINFO
      pi 	                            // pointer to PROCESS_INFORMATION
  ) then begin
    Error('   %s %s', [FileName, Params]);
  end;

  FreeMem(zFileName);
  FreeMem(zParams);
  FreeMem(zDir);

  Result :=pi.hProcess;
end;

procedure ExecCMD(const FileName:string; const Params:string; const DefaultDir:string; ShowCmd: Integer);
var ExecCMDDlg:TExecCMDDlg;
    h:THandle;
    res:cardinal;
    xParams:string;
begin
  xParams:='_ ' + Params;
  ExecCMDDlg:=TExecCMDDlg.Create(Application.MainForm);
  try
    h:=ExecuteFile(FileName, xParams, DefaultDir, SW_SHOW);
    ExecCMDDlg.Show;

    while not ExecCMDDlg.Terminated do begin
      res:=WaitForSingleObject(h, 500);
      case res of
        WAIT_FAILED,
        WAIT_ABANDONED,
        WAIT_OBJECT_0:  ExecCMDDlg.Terminated:=true;
        WAIT_TIMEOUT:   ;
      end;
      Application.ProcessMessages();
    end;
    ExecCMDDlg.Close;

  finally
    ExecCMDDlg.Free;
  end;
end;


end.
