unit Install;

var dx        = 600;
var dy        = 342;
var btntop    = dy - 60;
var gutter    = 150;

var panelcnt = 5;

var step = 1;

// setup var's /////////////////////////////////////////////////////////////////
var DelphiPath;
var Path;
var BackPath;

var CreateBackup    = true;

var BuildComponents = true;
  var ARInstall       = true;
  var ARDemoInstall   = true;
  var AIInstall       = true;
  var AIDemoInstall   = true;
////////////////////////////////////////////////////////////////////////////////

proc Start(object b)
  var CurrPath = FilePath(ParamStr(0)) + '..';
  print(CurrPath);

  list fl;
// creating backup files
  if CreateBackup then
    b.Owner.ProgressLabel.Caption   =  'Creating backups files';

    MakeDir(BackPath);

    fl.RecurseDir(Path, '*.*');
    fl.first();
    b.Owner.progressbar.position = 0;
    b.Owner.progressbar.max      = max(fl.count - 1, 0);
    while not(fl.eof) do
      b.Owner.ProgressLabel.Caption   =  'Backuping files - ' + BackPath + fl.str;

      MakeDir(FilePath(BackPath + fl.str));

      MoveFile(Path + fl.str, BackPath + fl.str);
      fl.next();
      b.Owner.progressbar.position = fl.pos;
      ProcessMessages();
    endw
  endif

// copying files
  MakeDir(Path);

  fl.RecurseDir(CurrPath, '*.*');
  fl.first();
  b.Owner.progressbar.position = 0;
  b.Owner.progressbar.max      = max(fl.count - 1, 0);
  while not(fl.eof) do
    b.Owner.ProgressLabel.Caption   =  'Copying files - ' + Path + fl.str;

    MakeDir(FilePath(Path + fl.str));

    print(CurrPath + fl.str + '      ' + Path + fl.str);
    CopyFile(CurrPath + fl.str, Path + fl.str, false);
    fl.next();

    b.Owner.progressbar.position = fl.pos;
    ProcessMessages();
  endw

// installing selected components
  list bat;
  bat.clear();

  if BuildComponents then
    // AR Report components
    if ARInstall then
      bat.add('cd ' + Path + 'AR');
      bat.add('DCC32.exe -B ARInterbaseFS.dpk');
//      bat.add('pause');
      bat.add('DCC32.exe -B AR.dpk');
//      bat.add('pause');
      bat.add('DCC32.exe -B ARTemplatePropEditor.dpk');
//      bat.add('pause');
      bat.add('DCC32.exe -B AREditor.dpr');
//      bat.add('pause');
    endif

    if ARDemoInstall then
      bat.add('cd ' + Path + 'AR\Demo');
      bat.add('DCC32.exe -B ANDReportDemo.dpr');
//      bat.add('pause');
    endif

    if AIInstall then
      bat.add('cd ' + Path + 'AI');
      bat.add('DCC32.exe -B AI.dpk');
//      bat.add('pause');
    endif

    if AIDemoInstall then
      bat.add('cd ' + Path + 'AI\Demo');
      bat.add('DCC32.exe -B AIDemo.dpr');
//      bat.add('pause');
    endif

    if bat.count > 0 then
      bat.save(Path + 'Make.bat');
      print(ShellExecute('', 'Make.bat', Path, Path, 1));
    endif
  endif

  object reg;

  if BuildComponents then
    // register bpl's
    reg.Create('airegistry');
    reg.rootkey = 'HKEY_CURRENT_USER';

    if reg.openkey('\SOFTWARE\Borland\Delphi\5.0\Known Packages\', false) then
      reg.writestring(Path + 'AR\AR.bpl',                    'AND Report Components');
      reg.writestring(Path + 'AR\ARTemplatePropEditor.bpl',  '');
      reg.writestring(Path + 'AR\ARInterbaseFS.bpl',         '');
      reg.writestring(Path + 'AI\AI.bpl',                    'AND Interpreter');
    endif
  endif


// add help
  list sl;
  print('DELPHI : ' + DelphiPath);

  if DelphiPath <> '' then
    print(Path + 'Help\ANDCOMPONENTS.HLP -> ' + DelphiPath + 'Help\');
    CopyFile(Path + 'Help\ANDCOMPONENTS.HLP', DelphiPath + 'Help\ANDCOMPONENTS.HLP', false);
    print(Path + 'Help\ANDCOMPONENTS.CNT -> ' + DelphiPath + 'Help\');
    CopyFile(Path + 'Help\ANDCOMPONENTS.cnt', DelphiPath + 'Help\ANDCOMPONENTS.cnt', false);

    // delphi5.cnt
    //:Include ANDCOMPONENTS.CNT
    sl.load(DelphiPath + 'Help\delphi5.cnt');
    if sl.indexof(':Include ANDCOMPONENTS.CNT') < 0 then
      sl.add(':Include ANDCOMPONENTS.CNT');
      sl.save(DelphiPath + 'Help\delphi5.cnt');
    endif

    // delphi5.ohc
    //:INCLUDE ANDCOMPONENTS.cnt
    sl.load(DelphiPath + 'Help\delphi5.ohc');
    if sl.indexof(':INCLUDE ANDCOMPONENTS.cnt') < 0 then
      sl.add(':INCLUDE ANDCOMPONENTS.cnt');
      sl.save(DelphiPath + 'Help\delphi5.ohc');
    endif

    // delphi5.ohi
    //:INDEX AND Report=ANDCOMPONENTS.HLP
    sl.load(DelphiPath + 'Help\delphi5.ohi');
    if sl.indexof(':INDEX =ANDCOMPONENTS.HLP') < 0 then
      sl.add(':INDEX =ANDCOMPONENTS.HLP');
      sl.save(DelphiPath + 'Help\delphi5.ohi');
    endif

    // delphi5.ohl // TARUserRep
    //:LINK ANDCOMPONENTS.HLP
    sl.load(DelphiPath + 'Help\delphi5.ohl');
    if sl.indexof(':LINK ANDCOMPONENTS.HLP') < 0 then
      sl.add(':LINK ANDCOMPONENTS.HLP');
      sl.save(DelphiPath + 'Help\delphi5.ohl');
    endif

    // delphi5.ohp
    //ANDCOMPONENTS.cnt
    sl.load(DelphiPath + 'Help\delphi5.ohp');
    if sl.indexof('ANDCOMPONENTS.cnt') < 0 then
      sl.add('ANDCOMPONENTS.cnt');
      sl.save(DelphiPath + 'Help\delphi5.ohp');
    endif
  endif

// finallization

  b.Owner.progressbar.Visible   = false;
  b.Caption                     = 'Finish';
  b.Owner.BackBtn.Enabled       = false;

  b.Owner.ProgressLabel.Font.Name   = 'Times New Roman';
  b.Owner.ProgressLabel.Font.size   = 17;
  b.Owner.ProgressLabel.Font.color  = 255 * 256 * 256;
  b.Owner.ProgressLabel.Caption     = 'Installation Copmleted!';

  b.Owner.ResumeLabel1.Caption     = 'The installation of AND Report has been completed.';
  b.Owner.ResumeLabel2.Caption     = 'Press Finish button to exit this installation.';
//
end

proc closebtnclick(object b)
  Terminate();
end

func button(object Owner, var Left, var Top, var Name, var Caption, var onclick):object
  result.Create('button');
  result.Name     = Name;
  result.Owner    = Owner;
  result.Parent   = Owner;
  result.Left     = Left;
  result.Top      = Top;
  result.Caption  = Caption;
  result.onclick  = onclick;
end

func radiogroup(object Owner, object Parent, var Left, var Top, var Width, var Height, var Name, var Caption):object
  result.Create('radiogroup');
  result.Name     = Name;
  result.Owner    = Owner;
  result.Parent   = Parent;
  result.SetBounds(Left, Top, Width, Height);
  result.Caption  = Caption;
end

func checkbox(object Owner, object Parent, var Left, var Top, var Name, var Caption, var onclick):object
  result.Create('checkbox');
  result.Name     = Name;
  result.Owner    = Owner;
  result.Parent   = Parent;
  result.Left     = Left;
  result.Top      = Top;
  result.Width    = (Parent.Width - Left) - 10;
  result.Caption  = Caption;
  result.checked  = true;
  result.onclick  = onclick;
end

func panel(object Owner, var Caption):object
  result.Create('panel');
  result.Owner    = Owner;
  result.Parent   = Owner;
  result.SetBounds(gutter, 10, dx - (gutter + 20), btntop - 20);
  result.Name     = Caption;
  result.Caption  = '';
  result.Visible  = false;
end

proc Show1Panel(object b)
end

proc Show2Panel(object b)
end

proc Show3Panel(object b)
end

proc Show4Panel(object b)
  b.Owner.ResumeMemo.Lines.Clear();

  b.Owner.ResumeMemo.Lines.Add('Destination path: ' + Path);

  if CreateBackup then
    b.Owner.ResumeMemo.Lines.Add('Create backups files at ' + BackPath);
  else
    b.Owner.ResumeMemo.Lines.Add('Don''t Create backups files');
  endif

  if BuildComponents then
    b.Owner.ResumeMemo.Lines.Add('Compile and install :');
    b.Owner.ResumeMemo.Lines.Add('    AND Report');
    b.Owner.ResumeMemo.Lines.Add('    AND Report Demo');
    b.Owner.ResumeMemo.Lines.Add('    AND Interpreter');
    b.Owner.ResumeMemo.Lines.Add('    AND Interpreter Demo');
  endif
end

proc Show5Panel(object b)
  Start(b);
end

proc Show6Panel(object b)
  Terminate();
end

proc ShowNPanel(object b)
  if step == 1 then
    Show1Panel(b);
  else if step == 2 then
    Show2Panel(b);
  else if step == 3 then
    Show3Panel(b);
  else if step == 4 then
    Show4Panel(b);
  else if step == 5 then
    Show5Panel(b);
  else if step == 6 then
    Show6Panel(b);
  endif endif endif endif endif endif
end

proc nextbtnclick(object b)
  b.Owner['panel' + step]['Visible'] = false;
  step = step + 1;

  b.Owner.BackBtn.Enabled = step > 1;

  b.Owner['panel' + step]['Visible'] = true;
  ShowNPanel(b);
end

proc backbtnclick(object b)
  b.Owner['panel' + step]['Visible'] = false;
  step = max(step - 1, 1);
  b.Owner.BackBtn.Enabled = step > 1;
  b.Owner['panel' + step]['Visible'] = true;
  ShowNPanel(b);
end

// control's events ////////////////////////////////////////////////////////////
proc browsebtnclick(object b)
  object browsepath;
  browsepath.Create('SelectDirectory');
  browsepath.Path = b.Owner.PathEdit.Text;
  var s = browsepath.Path;
  if s <> '' then
    b.Owner.PathEdit.Text = s;
    b.Owner.BackPathEdit.Text = s + '\Back\';
    Path     = b.Owner.PathEdit.Text;
    BackPath = b.Owner.BackPathEdit.Text;
  endif
end

proc PathEditChange(object edit)
  edit.Owner.BackPathEdit.Text = edit.Owner.PathEdit.Text + '\Back\';

  Path     = edit.Owner.PathEdit.Text;
  BackPath = edit.Owner.BackPathEdit.Text;
end

proc CreateBackupCBClick(object cb)
  CreateBackup = cb.Checked;
end

proc BuildComponentsCBClick(object cb)
  BuildComponents = cb.Checked;
end

proc ARInstallCBClick(object cb)
  ARInstall = cb.Checked;
end

proc ARDemoInstallCBClick(object cb)
  ARDemoInstall = cb.Checked;
end

proc AIInstallCBClick(object cb)
  AIInstall = cb.Checked;
end

proc AIDemoInstallCBClick(object cb)
  AIDemoInstall = cb.Checked;
end

proc backbrowsebtnclick(object b)
  object browsepath;
  browsepath.Create('SelectDirectory');
  browsepath.Path = b.Owner.BackPathEdit.Text;
  var s = browsepath.Path;
  if s <> '' then
    b.Owner.BackPathEdit.Text = s;
    BackPath = b.Owner.BackPathEdit.Text;
  endif
end

////////////////////////////////////////////////////////////////////////////////

proc Run()
  object  f;
  f.Create('form');
  f.formstyle   = 3;  //fsMDIChild
  f.SetBounds((ScreenWidth - dx) / 2, (ScreenHeight - dy) /2, dx, dy);
  f.borderstyle = 4;  //bsNone;
  f.Caption     = 'AND Report Install';
  f.Font.size   = 0 - 13;
  f.Visible     = true;

    object logo;
    logo.Create('aiimage');
    logo.Owner  = f;
    logo.Parent = f;
    logo.SetBounds(10, 10, gutter - 20, f.Height - 20);
    logo.Path   = FilePath(ParamStr(0)) + 'ARInst.BMP';

    object nextbtn  = button(f, dx - 180, btntop, 'nextbtn', '&Next >>', addr(nextbtnclick));
    nextbtn.default = true;

    object BackBtn  = button(f, dx - 260, btntop, 'BackBtn', '<< &Back', addr(backbtnclick));

    object closebtn = button(f, dx - 100, btntop, 'closebtn', '&Exit',   addr(closebtnclick));
    closebtn.Owner  = f;
    closebtn.cancel = true;

// 1
  object p1 = panel(f, 'panel1');

    object license;
    license.Create('memo');
    license.Owner        = f;
    license.Parent       = p1;
    license.SetBounds(10, 10, p1.Width - 20, p1.Height - 20);
    license.color        = f.color;
    license.scrollbars   = 2; //ssVertical
    license.readonly     = true;
    license.wantreturns  = false;
    license.lines.loadfromfile(FilePath(ParamStr(0)) + '..\license.txt');

// 2
  object p2 = panel(f, 'panel2');

    object RGPath = radiogroup(f, p2, 10, 10, p2.Width - 20, 50, 'rgpath', 'AND Report Destination Directory');

      object PathEdit;
      PathEdit.Create('edit');
      PathEdit.Name     = 'PathEdit';
      PathEdit.Owner    = f;
      PathEdit.Parent   = rgpath;
      PathEdit.Left     = 10;
      PathEdit.Top      = 20;
      PathEdit.Width    = rgpath.Width - 80;
      PathEdit.Text     = '';
      PathEdit.onchange = addr(PathEditChange);

      object browsetbtn = button(f, PathEdit.Left + PathEdit.Width , 20, 'browsebtn', '&Browse...', addr(browsebtnclick));
      browsetbtn.Parent = rgpath;
      browsetbtn.Width  = 60;
      browsetbtn.Height = 20;

    object backlabel;
      backlabel.Create('label');
      backlabel.Owner     = p2;
      backlabel.Parent    = p2;
      backlabel.wordwrap  = true;

      backlabel.SetBounds(10, rgpath.Top + rgpath.Height + 10, p2.Width - 20, 50);
      backlabel.Caption   = 'This installation program can Create backup copies ' +
                            'of all files replaced during the installation. Do ' +
                            'you want to Create backups of the replaced files?';

    object CreateBackupCB = checkbox(f, p2, 100, backlabel.Top + backlabel.Height + 10,
                                      'CreateBackupCB',  '&Yes, Create backups.',
                                      addr(CreateBackupCBClick));
    CreateBackupCB.Checked = CreateBackup;

    object rgbackpath = radiogroup(f, p2, 10, CreateBackupCB.Top + CreateBackupCB.Height + 10, p2.Width - 20, 50, 'rgbackpath', 'Backup File Destination Directory');
      object BackPathEdit;
      BackPathEdit.Create('edit');
      BackPathEdit.Name   = 'BackPathEdit';
      BackPathEdit.Owner  = f;
      BackPathEdit.Parent = rgbackpath;
      BackPathEdit.Left   = 10;
      BackPathEdit.Top    = 20;
      BackPathEdit.Width  = rgbackpath.Width - 80;
      BackPathEdit.Text   = '';

      object backbrowsetbtn = button(f, BackPathEdit.Left + BackPathEdit.Width , 20, 'backbrowsetbtn', 'Browse...', addr(backbrowsebtnclick));
      backbrowsetbtn.Parent = rgbackpath;
      backbrowsetbtn.Width  = 60;
      backbrowsetbtn.Height = 20;

    var s;
    var pos;

    object reg;
    reg.Create('airegistry');

    PathEdit.Text = '';

    reg.rootkey = 'HKEY_CLASSES_ROOT';
    if reg.openkey('\ARTemplate\Shell\Open\Command', false) then
      s = FilePath(reg.readstring(''));
      if s <> '' then
        pos = strpos('\ar\', s);
        if pos then
          PathEdit.Text = strcopy(s, 1, pos);
        else
          PathEdit.Text = s;
        endif
      endif
    endif

    reg.rootkey = 'HKEY_LOCAL_MACHINE';
    if reg.openkey('\SOFTWARE\Borland\Delphi\5.0', false) then
      DelphiPath = reg.readstring('RootDir') + '\';
    endif

    if PathEdit.Text == '' then
      PathEdit.Text = DelphiPath;
      if PathEdit.Text <> '' then
        PathEdit.Text = PathEdit.Text + 'AND\';
      endif
    endif

    PathEdit.Text     = 'c:\and\'; // ??
    BackPathEdit.Text = PathEdit.Text + 'Back\';

    Path      = PathEdit.Text;
    BackPath  = BackPathEdit.Text;
// 3
  object p3 = panel(f, 'panel3');

    object selectinslabel;
      selectinslabel.Create('label');
      selectinslabel.Owner     = p3;
      selectinslabel.Parent    = p3;
      selectinslabel.wordwrap  = true;

      selectinslabel.SetBounds(10, 10, p3.Width - 20, 50);
      selectinslabel.Caption   = 'Please, select the components you wish to install.';

    object BuildComponentsCB = checkbox(f, p3, 20, selectinslabel.Top + selectinslabel.Height + 20,
                                        'BuildComponentsCB', 'Compile and install following components',
                                        addr(BuildComponentsCBClick));
    BuildComponentsCB.Checked = BuildComponents;

    object rgar = radiogroup(f, p3, 10, BuildComponentsCB.Top + BuildComponentsCB.Height + 20, p3.Width - 20, 70, 'rgar', 'AND Report');
      object  ARInstallCB = checkbox(f, rgar, 10, 20,     'ARInstallCB',      'AND Report Components',      addr(ARInstallCBClick));
              ARInstallCB.Checked     = ARInstall;
      object  ARDemoInstallCB = checkbox(f, rgar, 40, 40, 'ARDemoInstallCB',  'AND Report Demo',            addr(ARDemoInstallCBClick));
              ARDemoInstallCB.Checked = ARDemoInstall;

    object rgai = radiogroup(f, p3, 10, rgar.Top + rgar.Height + 10, p3.Width - 20, 70, 'rgai', 'AND Interpreter');
      object  AIInstallCB = checkbox(f, rgai, 10, 20,     'AIInstallCB',      'AND Interpreter Components', addr(AIInstallCBClick));
              AIInstallCB.Checked     = AIInstall;
      object  AIDemoInstallCB = checkbox(f, rgai, 40, 40, 'AIDemoInstallCB',  'AND Interpreter Demo',       addr(AIDemoInstallCBClick));
              AIDemoInstallCB.Checked = AIDemoInstall;

// 4
  object p4 = panel(f, 'panel4');

    object selectinslabel1;
      selectinslabel1.Create('label');
      selectinslabel1.Owner     = p4;
      selectinslabel1.Parent    = p4;
      selectinslabel1.wordwrap  = true;

      selectinslabel1.SetBounds(10, 20, p4.Width - 20, 50);
      selectinslabel1.Caption   =  'You are now ready to install AND Report Components.' +

    object ResumeMemo;
      ResumeMemo.Create('memo');
      ResumeMemo.Name         = 'ResumeMemo';
      ResumeMemo.Owner        = f;
      ResumeMemo.Parent       = p4;
      ResumeMemo.SetBounds(10, selectinslabel1.Top + selectinslabel1.Height + 10, p4.Width - 20, p4.Height - 100);
      ResumeMemo.color        = f.color;
      ResumeMemo.scrollbars   = 2; //ssVertical
      ResumeMemo.readonly     = true;
      ResumeMemo.wantreturns  = false;

    object selectinslabel2;
      selectinslabel2.Create('label');
      selectinslabel2.Owner     = p4;
      selectinslabel2.Parent    = p4;
      selectinslabel2.wordwrap  = true;

      selectinslabel2.SetBounds(10, ResumeMemo.Top + ResumeMemo.Height + 10, p4.Width - 20, 50);
      selectinslabel2.Caption   = 'Press Next button to begin the installation or the ' +
                                  'Back button to reenter the installation information.';
// 5
  object p5 = panel(f, 'panel5');

    object ProgressLabel;
      ProgressLabel.Create('Label');
      ProgressLabel.Name      = 'ProgressLabel';
      ProgressLabel.Owner     = f;
      ProgressLabel.Parent    = p5;
      ProgressLabel.alignment = 2;  // alCenter
      ProgressLabel.SetBounds(10, 20, p5.Width - 20, 16);
      ProgressLabel.Caption   =  '';

    object progressbar;
      progressbar.Create('progressbar');
      progressbar.Name      = 'progressbar';
      progressbar.Owner     = f;
      progressbar.Parent    = p5;
      progressbar.SetBounds(10, ProgressLabel.Top + ProgressLabel.Height + 20, p5.Width - 20, 16);

    object ResumeLabel1;
      ResumeLabel1.Create('Label');
      ResumeLabel1.Name     = 'ResumeLabel1';
      ResumeLabel1.Owner    = f;
      ResumeLabel1.Parent   = p5;
      ResumeLabel1.SetBounds(10, ProgressLabel.Top + ProgressLabel.Height + 60, p5.Width - 20, 16);
      ResumeLabel1.Caption  = '';

    object ResumeLabel2;
      ResumeLabel2.Create('Label');
      ResumeLabel2.Name     = 'ResumeLabel2';
      ResumeLabel2.Owner    = f;
      ResumeLabel2.Parent   = p5;
      ResumeLabel2.SetBounds(10, ResumeLabel1.Top + ResumeLabel1.Height + 20, p5.Width - 20, 16);
      ResumeLabel2.Caption  = '';
// 6
  object p6 = panel(f, 'panel6');
//

  step = 1;
  p1.Visible = true;
  BackBtn.Enabled = step > 1;
end

Run();