unit SelectDir;

interface

uses
  Windows, Classes, Forms, Messages, CommDlg, FileCtrl, Dialogs, Controls;

type
  TSelectDirectory = class(TPersistent)
  private
    FPath     :string;
  protected
    function  GetPath:string;virtual;
    procedure SetPath(APath:string);virtual;
  published
    property  Path:string read GetPath write SetPath;
  end;

implementation

procedure CenterWindow(Wnd: HWnd);
var
  Rect: TRect;
  Monitor: TMonitor;
begin
  GetWindowRect(Wnd, Rect);
  if Application.MainForm <> nil then
    Monitor := Application.MainForm.Monitor
  else
    Monitor := Screen.Monitors[0];
  SetWindowPos(Wnd, 0,
    Monitor.Left + ((Monitor.Width - Rect.Right + Rect.Left) div 2),
    Monitor.Top + ((Monitor.Height - Rect.Bottom + Rect.Top) div 3),
    0, 0, SWP_NOACTIVATE or SWP_NOSIZE or SWP_NOZORDER);
end;

function  OFNHookProc(wnd:HWND;	Msg:cardinal;	wParam:integer;	lParam:integer):cardinal;stdcall;
var PPath:PChar;
    dlgwnd:HWND;
begin
  Result:=Ord(true);
  case Msg of
    WM_NOTIFY:
      begin
        dlgwnd:=POFNOTIFY(lParam)^.hdr.hwndFrom;
        case POFNOTIFY(lParam)^.hdr.code of
          CDN_INITDONE:
            begin
              SendMessage(dlgwnd, CDM_HIDECONTROL,     $0470, 0); //filetype combobox
              SendMessage(dlgwnd, CDM_HIDECONTROL,     $0441, 0); //label of filetype combobox
              SendMessage(dlgwnd, CDM_HIDECONTROL,     $0410, 0); //readonly combobox

              PPath:='Folder';
              SendMessage(dlgwnd, CDM_SETCONTROLTEXT,  $0442, integer(PPath));//label of falename edit

              PPath:='Select';
              SendMessage(dlgwnd, CDM_SETCONTROLTEXT, IDOK, integer(PPath));//label of OK button

              CenterWindow(GetWindowLong(wnd, GWL_HWNDPARENT));
            end;
          CDN_FOLDERCHANGE,
          CDN_SELCHANGE:
            begin
              GetMem(PPath, 260);
              SendMessage(dlgwnd, CDM_GETFOLDERPATH, 260, integer(PPath));

              SendMessage(dlgwnd, CDM_SETCONTROLTEXT, $0480, integer(PPath));//label of OK button

              FreeMem(PPath);
            end;
          CDN_FILEOK	:
            begin
              Result:=2;
            end;
        end;
      end;
    WM_CHILDACTIVATE:
      begin
        Result:=0;
      end;
  end;
end;

procedure TSelectDirectory.SetPath(APath:string);
begin
  FPath:=APath;
end;

function  TSelectDirectory.GetPath:string;
var ofn:OPENFILENAME;
    szFile:array[0..260] of char;
begin
  Result:='';

  FillChar(ofn, sizeof(OPENFILENAME), 0);
  ofn.lStructSize     := sizeof(OPENFILENAME);
  ofn.hwndOwner       := Application.MainForm.Handle;
  ofn.hInstance       := hInstance;
  ofn.lpstrFile       := szFile;
  ofn.nMaxFile        := sizeof(szFile);
  ofn.nFilterIndex    := 1;
  ofn.nMaxFileTitle   := 0;
  ofn.lpstrInitialDir := nil;
  ofn.Flags           := OFN_EXPLORER or
                         OFN_ENABLEHOOK or
                         OFN_NOTESTFILECREATE or
                         OFN_NOVALIDATE;
  ofn.lpfnHook        := OFNHookProc;
  ofn.lpstrTitle      := 'Destination path';
  ofn.lpstrInitialDir :=PChar(FPath);


  if (GetOpenFileName(ofn) = true) then begin
    Result:=ofn.lpstrFile;
    if not DirectoryExists(Result) then begin
      if MessageDlg('Path ' + Result + ' not exists, create it?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
        ForceDirectories(Result);
      end else begin
        Result:='';
      end;
    end;
  end;
end;

initialization
  RegisterClasses([TSelectDirectory]);
end.
